package com.jaywagnon.webservices.persistence.entity;


import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;


@Entity
@Table(name = "users")
@SequenceGenerator(name = "users_seq", sequenceName = "users_seq")
public class User
        implements Serializable
{
  @Id
  @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "users_seq")
  private Long id;

  @Column(name = "created", nullable = false)
  private Date created;

  @Column(name = "updated", nullable = false)
  private Date updated;

  @Column(name = "first_name", nullable = false)
  private String firstName;

  @Column(name = "last_name", nullable = false)
  private String lastName;


  public Long getId()
  {
    return id;
  }


  public User setId(Long id)
  {
    this.id = id;
    return this;
  }


  public Date getCreated()
  {
    return created;
  }


  public User setCreated(Date created)
  {
    this.created = created;
    return this;
  }


  public Date getUpdated()
  {
    return updated;
  }


  public User setUpdated(Date updated)
  {
    this.updated = updated;
    return this;
  }


  public String getFirstName()
  {
    return firstName;
  }


  public User setFirstName(String firstName)
  {
    this.firstName = firstName;
    return this;
  }


  public String getLastName()
  {
    return lastName;
  }


  public User setLastName(String lastName)
  {
    this.lastName = lastName;
    return this;
  }


  @PrePersist
  public void prePresist()
  {
    this.created = new Date();
  }


  @PreUpdate
  public void preUpdate()
  {
    this.updated = new Date();
  }
}
