package com.jaywagnon.webservices.web.model;


import org.hibernate.validator.constraints.Length;
import org.hibernate.validator.constraints.NotEmpty;


public class UserDTO
{
  @NotEmpty
  @Length(max = 64)
  private String firstName;

  @NotEmpty
  @Length(max = 64)
  private String lastName;


  public String getFirstName()
  {
    return firstName;
  }


  public UserDTO setFirstName(String firstName)
  {
    this.firstName = firstName;
    return this;
  }


  public String getLastName()
  {
    return lastName;
  }


  public UserDTO setLastName(String lastName)
  {
    this.lastName = lastName;
    return this;
  }


  @Override
  public boolean equals(Object o)
  {
    if(this == o) return true;
    if(o == null || getClass() != o.getClass()) return false;

    UserDTO userDTO = (UserDTO) o;

    if(firstName != null ? !firstName.equals(userDTO.firstName) : userDTO.firstName != null) return false;
    if(lastName != null ? !lastName.equals(userDTO.lastName) : userDTO.lastName != null) return false;

    return true;
  }


  @Override
  public int hashCode()
  {
    int result = firstName != null ? firstName.hashCode() : 0;
    result = 31 * result + (lastName != null ? lastName.hashCode() : 0);
    return result;
  }
}
