package com.jaywagnon.webservices.web.resources;


import com.jaywagnon.webservices.persistence.entity.User;
import com.jaywagnon.webservices.web.controller.UsersController;
import org.springframework.hateoas.mvc.ResourceAssemblerSupport;
import org.springframework.stereotype.Component;


@Component
public class UserResourceAssembler
        extends ResourceAssemblerSupport<User, UserResource>
{
  public UserResourceAssembler()
  {
    super(UsersController.class, UserResource.class);
  }


  @Override
  public UserResource toResource(User user)
  {
    UserResource resource = createResourceWithId(user.getId(), user);
    return resource;
  }


  @Override
  protected UserResource instantiateResource(User user)
  {
    return new UserResource()
            .setCreated(user.getCreated())
            .setUpdated(user.getUpdated())
            .setFirstName(user.getFirstName())
            .setLastName(user.getLastName());
  }
}
