package com.jaywagnon.webservices.web.model;


import org.junit.Test;

import static junit.framework.TestCase.*;


public class UserDTOTest
{
  @Test
  public void test_Constructor()
  {
    assertNotNull(new UserDTO());
  }


  @Test
  public void test_firstName()
  {
    UserDTO object = new UserDTO();

    String name = "Name";
    assertNull(object.getFirstName());

    object.setFirstName(name);
    assertEquals(name, object.getFirstName());
  }


  @Test
  public void test_lastName()
  {
    UserDTO object = new UserDTO();

    String name = "Name";
    assertNull(object.getLastName());

    object.setLastName(name);
    assertEquals(name, object.getLastName());
  }


  @Test
  public void test_equals()
  {
    UserDTO object1 = new UserDTO()
            .setFirstName("First")
            .setLastName("Last");
    UserDTO object2 = new UserDTO()
            .setFirstName(object1.getFirstName())
            .setLastName(object1.getLastName());
    assertEquals(object1, object2);
  }


  @Test
  public void test_equals_same()
  {
    UserDTO object1 = new UserDTO()
            .setFirstName("First")
            .setLastName("Last");
    assertEquals(object1, object1);
  }


  @Test
  public void test_equals_nulls()
  {
    UserDTO object1 = new UserDTO()
            .setFirstName(null)
            .setLastName(null);
    UserDTO object2 = new UserDTO()
            .setFirstName(null)
            .setLastName(null);
    assertEquals(object1, object2);
  }


  @Test
  public void test_equals_notEquals_null()
  {
    UserDTO object1 = new UserDTO()
            .setFirstName("First")
            .setLastName("Last");
    assertFalse(object1.equals(null));
  }


  @Test
  public void test_equals_notEquals_otherClass()
  {
    UserDTO object1 = new UserDTO()
            .setFirstName("First")
            .setLastName("Last");
    assertFalse(object1.equals(new String()));
  }


  @Test
  public void test_equals_notEquals_firstName()
  {
    UserDTO object1 = new UserDTO()
            .setFirstName("First")
            .setLastName("Last");
    UserDTO object2 = new UserDTO()
            .setFirstName("Not")
            .setLastName("Last");
    assertFalse(object1.equals(object2));
    assertFalse(object2.equals(object1));
  }


  @Test
  public void test_equals_notEquals_null_firstName()
  {
    UserDTO object1 = new UserDTO()
            .setFirstName("First")
            .setLastName("Last");
    UserDTO object2 = new UserDTO()
            .setFirstName(null)
            .setLastName("Last");
    assertFalse(object1.equals(object2));
    assertFalse(object2.equals(object1));
  }


  @Test
  public void test_equals_notEquals_lastName()
  {
    UserDTO object1 = new UserDTO()
            .setFirstName("First")
            .setLastName("Last");
    UserDTO object2 = new UserDTO()
            .setFirstName("First")
            .setLastName("Not");
    assertFalse(object1.equals(object2));
    assertFalse(object2.equals(object1));
  }


  @Test
  public void test_equals_notEquals_null_lastName()
  {
    UserDTO object1 = new UserDTO()
            .setFirstName("First")
            .setLastName("Last");
    UserDTO object2 = new UserDTO()
            .setFirstName("First")
            .setLastName(null);
    assertFalse(object1.equals(object2));
    assertFalse(object2.equals(object1));
  }


  @Test
  public void test_hashCode()
  {
    UserDTO object1 = new UserDTO()
            .setFirstName("First")
            .setLastName("Last");
    UserDTO object2 = new UserDTO()
            .setFirstName(object1.getFirstName())
            .setLastName(object1.getLastName());
    assertTrue(object1.hashCode() == object2.hashCode());
  }


  @Test
  public void test_hashCode_notEquals_firstName()
  {
    UserDTO object1 = new UserDTO()
            .setFirstName("First")
            .setLastName("Last");
    UserDTO object2 = new UserDTO()
            .setFirstName("Not")
            .setLastName(object1.getLastName());
    assertTrue(object1.hashCode() != object2.hashCode());
  }


  @Test
  public void test_hashCode_notEquals_lastName()
  {
    UserDTO object1 = new UserDTO()
            .setFirstName("First")
            .setLastName("Last");
    UserDTO object2 = new UserDTO()
            .setFirstName(object1.getFirstName())
            .setLastName("Not");
    assertTrue(object1.hashCode() != object2.hashCode());
  }
}
